package com.gic.enterprise.service;

import com.gic.api.base.commons.Page;
import com.gic.api.base.commons.ServiceResponse;
import com.gic.enterprise.dto.rule.RuleClassifyDTO;
import com.gic.enterprise.dto.rule.RuleClassifySceneDTO;
import com.gic.enterprise.dto.rule.RuleDTO;

import java.util.List;

/**
 * 平台规则配置
 * @ClassName: ConfigRuleApiService 
 * @Description:  
 * @author guojuxing 
 * @date 2020/3/3 2:50 PM 
 */
public interface ConfigRuleApiService {

    /**
     * 新增规则
     * @Title: saveRule 
     * @Description:
     * @author guojuxing
     * @param dto 
     * @return  com.gic.api.base.commons.ServiceResponse<java.lang.Integer> 
     */
    ServiceResponse<Integer> saveRule(RuleDTO dto);

    ServiceResponse<Integer> editRule(RuleDTO dto);

    /**
     * 规则列表
     * @Title: listRule 
     * @Description:
     * @param search 规则名称
     * @author guojuxing  
     * @return  com.gic.api.base.commons.ServiceResponse<java.util.List<com.gic.enterprise.dto.rule.RuleDTO>> 
     */
    ServiceResponse<List<RuleDTO>> listRule(String search);
    /**
     * 分页查询分类列表
     * @Title: listRuleClassify 
     * @Description:
     * @author guojuxing
     * @param search 分类名称
     * @param ruleId 规则ID
     * @param pageNum
     * @param pageSize 
     * @return  com.gic.api.base.commons.ServiceResponse<com.gic.api.base.commons.Page<com.gic.enterprise.dto.rule.RuleClassifyDTO>> 
     */
    ServiceResponse<Page<RuleClassifyDTO>> listRuleClassify(String search, Integer ruleId, Integer pageNum, Integer pageSize);
    /**
     * 分页查询场景列表
     * @Title: listRuleClassifyScene 
     * @Description:
     * @author guojuxing
     * @param search 场景名称
     * @param ruleId 分类ID
     * @param pageNum
     * @param pageSize 
     * @return  com.gic.api.base.commons.ServiceResponse<com.gic.api.base.commons.Page<com.gic.enterprise.dto.rule.RuleClassifySceneDTO>> 
     */
    ServiceResponse<Page<RuleClassifySceneDTO>> listRuleClassifyScene(String search, Integer ruleId, Integer pageNum, Integer pageSize);
    /**
     * 新增分类
     * @Title: saveRuleClassify 
     * @Description:
     * @author guojuxing
     * @param dto 
     * @return  com.gic.api.base.commons.ServiceResponse<java.lang.Integer> 
     */
    ServiceResponse<Integer> saveRuleClassify(RuleClassifyDTO dto);
    ServiceResponse<String> editRuleClassify(RuleClassifyDTO dto);
    /**
     * 新增场景
     * @Title: saveRuleClassifyScene 
     * @Description:
     * @author guojuxing
     * @param dto 
     * @return  com.gic.api.base.commons.ServiceResponse<java.lang.Integer> 
     */
    ServiceResponse<Integer> saveRuleClassifyScene(RuleClassifySceneDTO dto);
    ServiceResponse<String> editRuleClassifyScene(RuleClassifySceneDTO dto);

    ServiceResponse<String> deleteRule(Integer ruleId);
    ServiceResponse<String> deleteRuleClassify(Integer ruleId);
    ServiceResponse<String> deleteRuleClassifyScene(Integer ruleId);
}
