package com.gic.operation.web.controller;

import com.gic.commons.webapi.reponse.RestResponse;
import com.gic.enterprise.dto.rule.RuleClassifyDTO;
import com.gic.enterprise.dto.rule.RuleClassifySceneDTO;
import com.gic.enterprise.dto.rule.RuleDTO;
import com.gic.enterprise.service.ConfigRuleApiService;
import com.gic.enterprise.utils.ResultControllerUtils;
import com.gic.operation.web.vo.SceneCategoryVO;
import com.gic.rule.manage.api.service.DealOperationApiService;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/config/rule")
public class ConfigRuleController {

    private static final Logger LOGGER = LogManager.getLogger(ConfigRuleController.class);

    @Autowired
    private ConfigRuleApiService configRuleApiService;
    @Autowired
    private DealOperationApiService dealOperationApiService;

    @RequestMapping("/saveRule")
    public RestResponse saveRule(RuleDTO dto) {
        return ResultControllerUtils.commonResult(configRuleApiService.saveRule(dto));
    }

    @RequestMapping("/editRule")
    public RestResponse editRule(RuleDTO dto) {
        return ResultControllerUtils.commonResult(configRuleApiService.editRule(dto));
    }

    @RequestMapping("/saveRuleClassify")
    public RestResponse saveRuleClassify(RuleClassifyDTO dto) {
        return ResultControllerUtils.commonResult(configRuleApiService.saveRuleClassify(dto));
    }

    @RequestMapping("/editRuleClassify")
    public RestResponse editRuleClassify(RuleClassifyDTO dto) {
        return ResultControllerUtils.commonResult(configRuleApiService.editRuleClassify(dto));
    }

    @RequestMapping("/saveRuleClassifyScene")
    public RestResponse saveRuleClassifyScene(RuleClassifySceneDTO dto) {
        return ResultControllerUtils.commonResult(configRuleApiService.saveRuleClassifyScene(dto));
    }

    @RequestMapping("/editRuleClassifyScene")
    public RestResponse editRuleClassifyScene(RuleClassifySceneDTO dto) {
        return ResultControllerUtils.commonResult(configRuleApiService.editRuleClassifyScene(dto));
    }

    @RequestMapping("/deleteClassify")
    public RestResponse deleteClassify(Integer ruleId) {
        return ResultControllerUtils.commonResult(configRuleApiService.deleteRuleClassify(ruleId));
    }

    @RequestMapping("/deleteClassifyScene")
    public RestResponse deleteClassifyScene(Integer ruleId) {
        return ResultControllerUtils.commonResult(configRuleApiService.deleteRuleClassifyScene(ruleId));
    }

    @RequestMapping("/list-scene")
    public RestResponse listScene(String search, Integer pageNum, Integer pageSize) {
        return ResultControllerUtils.commonPageResult(
                dealOperationApiService.pageSceneCategory(search, pageNum, pageSize), SceneCategoryVO.class);
    }
}
